#if !defined( __ASCPDEFS_H__ )
#define __ASCPDEFS_H__
/* ==========================================================================*/
/* - - - - - - - - - -   A S C P D E F S . H   - - - - - - - - - - - - - - - */
/* ==========================================================================*/
/*    Definition File for the ASCP protocol and Control Items                */
/*  Created 29-12-2001														 */
/*  Modified 08-02-2008		msw    added  CI_RX_IN/OUT_SAMPLE_TYPE           */
/* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

#define ASCP_INTERFACE_VERSION 5

/*---------------------------------------------------------------------------*/
/*---------------------> Message Header Defines <----------------------------*/
/*---------------------------------------------------------------------------*/
#define LENGTH_MASK 0x1FFF			/* mask for message length               */
#define TYPE_MASK 0xE0				/* mask for upper byte of header         */

#define TYPE_HOST_SET_CITEM (0<<5)
#define TYPE_HOST_REQ_CITEM (1<<5)
#define TYPE_HOST_REQ_CITEM_RANGE (2<<5)
#define TYPE_HOST_DATA_ITEM0 (4<<5)
#define TYPE_HOST_DATA_ITEM1 (5<<5)
#define TYPE_HOST_DATA_ITEM2 (6<<5)
#define TYPE_HOST_DATA_ITEM3 (7<<5)

#define TYPE_TARG_RESP_CITEM (0<<5)
#define TYPE_TARG_UNSOLICITED_CITEM (1<<5)
#define TYPE_TARG_RESP_CITEM_RANGE (2<<5)
#define TYPE_TARG_DATA_ITEM0 (4<<5)
#define TYPE_TARG_DATA_ITEM1 (5<<5)
#define TYPE_TARG_DATA_ITEM2 (6<<5)
#define TYPE_TARG_DATA_ITEM3 (7<<5)

#define TYPE_DATA_ITEM_ACK (3<<5)
 #define DATA_ITEM_ACK_LENGTH (3)

/*  2 byte NAK response to any unimplemented messages */
#define TARG_RESP_NAK (0x0002)

//#define MAX_MSG_LENGTH (8192+2)
#define MAX_MSG_LENGTH (16384+2)	//changed to accomodate new float format data msg
/*---------------------------------------------------------------------------*/
/*----------------------> Control Item Defines <-----------------------------*/
/*---------------------------------------------------------------------------*/

/*  General Interface Control Items  */
#define CI_GENERAL_INTERFACE_NAME 0x0001
 #define CI_GENERAL_INTERFACE_NAME_REQLEN 4

#define CI_GENERAL_INTERFACE_SERIALNUM 0x0002
 #define CI_GENERAL_INTERFACE_SERIALNUM_REQLEN 4

#define CI_GENERAL_INTERFACE_VERSION 0x0003
 #define CI_GENERAL_INTERFACE_VERSION_REQLEN 4
 #define CI_GENERAL_INTERFACE_VERSION_SETRESPLEN 6

#define CI_GENERAL_HARDFIRM_VERSION 0x0004
 #define CI_GENERAL_HARDFIRM_VERSION_REQLEN 5
 #define CI_GENERAL_HARDFIRM_VERSION_SETRESPLEN 7

#define CI_GENERAL_STATUS_CODE 0x0005
 #define CI_GENERAL_STATUS_CODE_REQLEN 4
 #define CI_GENERAL_STATUS_CODE_SETRESPLEN 5
  #define GENERAL_STATUS_IDLE 0x0B
  #define GENERAL_STATUS_BUSY 0x0C
  #define GENERAL_STATUS_6620LOADING 0x0D
  #define GENERAL_STATUS_BOOTIDLE 0x0E
  #define GENERAL_STATUS_BOOTBUSY 0x0F
  #define GENERAL_STATUS_BOOTERROR 0x80
  #define GENERAL_STATUS_ADOVERLOAD 0x20

#define CI_GENERAL_STATUS_STRING 0x0006
 #define CI_GENERAL_STATUS_STRING_REQLEN 4

#define CI_GENERAL_STATUS_PROGRESS 0x0007
 #define CI_GENERAL_STATUS_PROGRESS_REQLEN 4

#define CI_GENERAL_STATUS_TIME 0x0008
 #define CI_GENERAL_STATUS_TIME_REQLEN 4

/*  Receiver Specific Control Items  */
#define CI_RX_CHANNELS 0x0010
 #define CI_RX_CHANNELS_REQLEN 4

#define CI_RX_STATE 0x0018
 #define CI_RX_STATE_REQLEN 5
 #define CI_RX_STATE_SETRESPLEN 8
  #define RX_STATE_OFF 0x00
  #define RX_STATE_IDLE 0x01
  #define RX_STATE_ON 0x02

#define CI_RX_FREQUENCY 0x0020
 #define CI_RX_FREQUENCY_REQLEN 5
 #define CI_RX_FREQUENCY_SETRESPLEN 10

#define CI_RX_DEMODULATION 0x0028

#define CI_RX_DECODER 0x0030

#define CI_RX_RF_GAIN 0x0038
 #define CI_RX_RF_GAIN_REQLEN 5
 #define CI_RX_RF_GAIN_SETRESPLEN 6

#define CI_RX_IF_GAIN 0x0040
 #define CI_RX_IF_GAIN_REQLEN 5
 #define CI_RX_IF_GAIN_SETRESPLEN 6

#define CI_RX_RF_FILTER 0x0044
 #define CI_RX_RF_FILTER_REQLEN 5
 #define CI_RX_RF_FILTER_SETRESPLEN 6

#define CI_RX_AF_GAIN 0x0048
 #define CI_RX_AF_GAIN_REQLEN 5
 #define CI_RX_AF_GAIN_SETRESPLEN 6


#define CI_RX_AGC 0x0050

#define CI_RX_IF_BW 0x0058

#define CI_RX_LMS_FILTER 0x0060

#define CI_RX_NOTCH_FILTER 0x0068

#define CI_RX_IMPULSE_BLANKER 0x0070

#define CI_RX_AFC 0x0078

#define CI_RX_SQUELCH_THRESHOLD 0x0080

#define CI_RX_BFO_OFFSET 0x0088

#define CI_RX_SIGNAL_LEVEL 0x0090

#define CI_RX_SPECTRAL_DISPLAY 0x0098

#define CI_RX_SIGNAL_SRC 0x00A0
 #define CI_RX_SIGNAL_SRC_REQLEN 5
 #define CI_RX_SIGNAL_SRC_SETRESPLEN 6
 #define CI_RX_SIGNAL_SRC_NONE 0x00
 #define CI_RX_SIGNAL_SRC_ANT1 0x01
 #define CI_RX_SIGNAL_SRC_ANT2 0x02
 #define CI_RX_SIGNAL_SRC_INT1 0x21
 #define CI_RX_SIGNAL_SRC_INT2 0x22
 #define CI_RX_SIGNAL_SRC_INT3 0x23
 #define CI_RX_SIGNAL_SRC_INT4 0x24
 #define CI_RX_SIGNAL_SRC_REAL0 0x61
 #define CI_RX_SIGNAL_SRC_REAL1 0x62
 #define CI_RX_SIGNAL_SRC_IQ0 0x66
 #define CI_RX_SIGNAL_SRC_IQ1 0x67
 #define CI_RX_SIGNAL_SRC_REALFILE1 0x71
 #define CI_RX_SIGNAL_SRC_REALFILE2 0x72
 #define CI_RX_SIGNAL_SRC_IQFILE1 0x81
 #define CI_RX_SIGNAL_SRC_IQFILE2 0x82

#define CI_RX_DEMOD_DEST 0x00A8
 #define CI_RX_DEMOD_DEST_NONE 0x00
 #define CI_RX_DEMOD_DEST_INSPKR 0x01
 #define CI_RX_DEMOD_DEST_EXTSPKR 0x02
 #define CI_RX_DEMOD_DEST_PHONES 0x03
 #define CI_RX_DEMOD_DEST_BIINSPKR 0x04
 #define CI_RX_DEMOD_DEST_BIEXTSPKR 0x05
 #define CI_RX_DEMOD_DEST_BIPHONES 0x06
 #define CI_RX_DEMOD_DEST_AUX1 0x11
 #define CI_RX_DEMOD_DEST_AUX2 0x12
 #define CI_RX_DEMOD_DEST_BIAUX1 0x21
 #define CI_RX_DEMOD_DEST_BIAUX2 0x22
 #define CI_RX_DEMOD_DEST_REALFILE1 0x41
 #define CI_RX_DEMOD_DEST_REALFILE2 0x42
 #define CI_RX_DEMOD_DEST_IQFILE1 0x51
 #define CI_RX_DEMOD_DEST_IQFILE2 0x52


#define CI_RX_IN_SAMPLE_RATE 0x00B0
 #define CI_RX_IN_SAMPLE_RATE_REQLEN 5
 #define CI_RX_IN_SAMPLE_RATE_SETRESPLEN 9

#define CI_RX_OUT_SAMPLE_RATE 0x00B8
 #define CI_RX_OUT_SAMPLE_RATE_REQLEN 5
 #define CI_RX_OUT_SAMPLE_RATE_SETRESPLEN 9

#define CI_RX_IN_FILE_PARAMS 0x00C0
 #define CI_RX_IN_FILE_PARAMS_REQLEN 5

#define CI_RX_OUT_FILE_PARAMS 0x00C8
 #define CI_RX_OUT_FILE_PARAMS_REQLEN 5
 #define CI_RX_OUT_FILE_PARAMS_SETRESPLEN 9

/*  Transmitter Specific Control Items  */
#define CI_TX_CHANNELS 0x0100
 #define CI_TX_CHANNELS_REQLEN 4

#define CI_TX_STATE 0x0108
 #define CI_TX_STATE_REQLEN 5
 #define CI_TX_STATE_SETRESPLEN 6
  #define TX_STATE_OFF 0x00
  #define TX_STATE_IDLE 0x01
  #define TX_STATE_ON 0x02

#define CI_TX_CWKEY_STATE 0x0110
 #define CI_TX_CWKEY_STATE_REQLEN 5
 #define CI_TX_CWKEY_STATE_SETRESPLEN 6

#define CI_TX_PTT_STATE 0x0118
 #define CI_TX_PTT_STATE_REQLEN 5
 #define CI_TX_PTT_STATE_SETRESPLEN 6

#define CI_TX_FREQUENCY 0x0120
 #define CI_TX_FREQUENCY_REQLEN 5
 #define CI_TX_FREQUENCY_SETRESPLEN 10

#define CI_TX_MODULATION 0x0128

#define CI_TX_ENCODER 0x0130

#define CI_TX_RF_POWER 0x0138

#define CI_TX_MIC_GAIN 0x0140

#define CI_TX_COMPRESSION 0x0148

#define CI_TX_CW_SIDETONE_PITCH 0x0150
 #define CI_TX_CW_SIDETONE_PITCH_REQLEN 5 
 #define CI_TX_CW_SIDETONE_PITCH_SETRESPLEN 7 

#define CI_TX_CW_SIDETONE_AMPLITUDE 0x0158
 #define CI_TX_CW_SIDETONE_AMPLITUDE_REQLEN 5
 #define CI_TX_CW_SIDETONE_AMPLITUDE_SETRESPLEN 6

#define CI_TX_CW_KEYER_SETTINGS 0x0160

#define CI_TX_VOX_SETTINGS 0x0168

#define CI_TX_SWR_MEASUREMENT 0x0170

#define CI_TX_SPECTRAL_DISPLAY 0x0178

#define CI_TX_MODULATION_SRC 0x0180

#define CI_TX_SIGNAL_DEST 0x0188

#define CI_TX_IN_SAMPLE_RATE 0x0190

#define CI_TX_OUT_SAMPLE_RATE 0x0198

#define CI_TX_IN_FILE_PARAMS 0x01A0

#define CI_TX_OUT_FILE_PARAMS 0x01A8

/* Aux Port Control Items  */
#define CI_OPEN_ASYNC_PORT 0x0200
 #define CI_OPEN_ASYNC_PORT_SETRESPLEN 14
#define CI_CLOSE_ASYNC_PORT 0x0201
 #define CI_CLOSE_ASYNC_PORT_SETRESPLEN 5

#define CI_OPEN_SPI_PORT 0x0202
 #define CI_OPEN_SPI_PORT_SETRESPLEN 13
 #define CI_OPEN_SPI_PORT_MASTER 1
 #define CI_OPEN_SPI_PORT_SLAVE 0
 #define CI_OPEN_SPI_PORT_POSCLK_TRAIL 0	//inactive clk low, tx data change trail edge
 #define CI_OPEN_SPI_PORT_POSCLK_LEAD 1		//inactive clk low, tx data change lead edge
 #define CI_OPEN_SPI_PORT_NEGCLK_TRAIL 2	//inactive clk high, tx data change trail edge
 #define CI_OPEN_SPI_PORT_NEGCLK_LEAD 3		//inactive clk high, tx data change lead edge
#define CI_CLOSE_SPI_PORT 0x0203
 #define CI_CLOSE_SPI_PORT_SETRESPLEN 5

#define CI_OPEN_I2C_PORT 0x0204
 #define CI_OPEN_I2C_PORT_SETRESPLEN 11
 #define CI_OPEN_I2C_PORT_MASTER 1
 #define CI_OPEN_I2C_PORT_SLAVE 0
#define CI_CLOSE_I2C_PORT 0x0205
 #define CI_CLOSE_I2C_PORT_SETRESPLEN 5

/*  Antenna Control Items  */

/*  Software/Firmware Update MODE Control Items  */
#define CI_UPDATE_MODE_CONTROL 0x0300
 #define CI_UPDATE_MODE_CONTROL_SETREQLEN 10
 #define CI_UPDATE_MODE_CONTROL_SETRESPLEN 10
 #define CI_UPDATE_MODE_CONTROL_ENTER 0
 #define CI_UPDATE_MODE_CONTROL_START 1
 #define CI_UPDATE_MODE_CONTROL_END 2
 #define CI_UPDATE_MODE_CONTROL_ABORT 3
 #define CI_UPDATE_MODE_CONTROL_ERASE 4


 #define BOOTSECURE0 0x5A	// The next 4 bytes are security codes for entering
 #define BOOTSECURE1 0xFF	// the programming mode
 #define BOOTSECURE2 0xA5
 #define BOOTSECURE3 0x00

#define CI_UPDATE_MODE_PARAMS 0x0302
 #define CI_UPDATE_MODE_PARAMS_SETREQLEN 5
 #define CI_UPDATE_MODE_PARAMS_SETRESPLEN 17

#endif //!defined( __ASCPDEFS_H__ )
